from byubit import Bit

# This solution just keeps moving forward no matter what, then jumps and falls as needed.


def jump(bit):
    """
    Bit has a hurdle in front of it. Jump up to the top of the ledge.
    """
    bit.left()
    while not bit.right_clear():
        bit.move()
        bit.paint('green')
    bit.right()
    bit.move()
    bit.paint('green')


def fall(bit):
    """
    Bit is floating in air. Fall down.
    """
    bit.right()
    while bit.front_clear():
        bit.move()
        bit.paint('green')
    bit.left()


@Bit.run('hurdles', 'more-hurdles')
def run(bit):
    bit.paint('green')
    while bit.left_clear():
        if not bit.front_clear():
            # if the front is not clear, then jump up to the top of the ledge
            jump(bit)
        elif bit.right_clear():
            # if the right is clear then fall down
            fall(bit)
        else:
            # otherwise we can keep moving
            bit.move()
            bit.paint('green')