# solution
from byubit import Bit

# This solution moves forward and then jumps hurdles that get in the way.


def go_green(bit):
    """
    Bit moves forward until blocked, painting green on the way
    The first square is not painted; the last square IS painted.
    """
    while bit.front_clear():
        bit.move()
        bit.paint('green')


def cover_green(bit):
    """
    Bit moves forward until the right side is clear, painting green on the way
    The first square is not painted; the last square IS painted.
    """
    while not bit.right_clear():
        bit.move()
        bit.paint('green')


def jump_hurdle(bit):
    """
    Bit starts at base of hurdle on left side facing right
    Bit ends at base of hurdle on right side facing right
    """
    # Up
    bit.left()
    cover_green(bit)
    bit.right()
    # Over
    bit.move()
    bit.paint('green')
    cover_green(bit)
    # Down
    bit.right()
    go_green(bit)
    bit.left()


@Bit.run('hurdles', 'more-hurdles')
def run(bit):
    bit.paint('green')
    # we move as long as the left is clear (because the stopping point has
    # a block above Bit)
    while bit.left_clear():
        # move forward as long as we can, painting green as we go
        if bit.front_clear():
            bit.move()
            bit.paint('green')
            # go_green(bit)
        else:
            # jump a hurdle
            jump_hurdle(bit)
